%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
%              									%
% Nom:          Jezz-Ball v0.31 						%
% Auteurs: 	Guillaume, Lilian et Denis    				    	%
%										%
% Page web:	http://www.hp-sources.com/Jezz-Ball/Jezz-Ball.htm		%
%					                                        %
%										% 	
% Description: source du jeu sur HP48, 49 et HP3940 a compiler avec MASD	%
%										%
%										%
% Pr-requis : Copier CURSUP.GRO , CURSRIGHT.GRO , BOX.GRO et BALLE.GRO 	%
%	       dans le meme repertoire						%
%										%
%								  		%
% Gestion interne:								%
%		D0 = Adresse des variables, toujours vrai en sortie de fonction	%
%		P = 0 : toujours vrai en sortie de fonction			%
%		R0 = adresse balle en cours / sauvegarde trait 	       		%
%		R1 = sauvegarde trait						%
%		R2 = sauvegarde adresse ligne 					%
%		R3								%
%		R4.A = Adresse des variables					%
%		ST(0) = 1 si deplacement du curseur en horizontale, 0 si verti. %
%		ST(1) = 1 si le bouton VAR a t press, remis a 0 quand lach  %
%		ST(2) = 1 si trait en train d'etre trac			%
%		ST(3) = 1 si remplissage a droite/bas sinon gauche/haut		%
%		ST(4) = 							%
%		ST(5) = 							%
%		ST(6) = 							%
%		ST(7) = 							%
%		ST(8) = 							%
%		ST(9) = 							%
%		ST(10)= 							%
%		ST(11)= 							%
%										%
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
!RPL
!NO CODE
::

GARBAGE
TURNMENUOFF
HARDBUFF

CODE   

DC DISP1CTL	00120	% affichage

CP=00000

DCCP 2 coord_X		% coordonne X du curseur
DCCP 2 coord_Y		% coordonne Y

DCCP 5 ECRAN_AFF	% ecran d'affichage
DCCP 5 ECRAN_TRAVAIL	% ecran de travail
DCCP 5 ECRAN_FOND	% ecran contenant le fond
DCCP 5 ECRAN_TRAIT	% ecran contenant le trait ou les rectangles de remplissage

DCCP 5 GROB_BOX		% contenu du GROB BOX.GRO
DCCP 5 GROB_CURS_VERTI	% contenu du GROB CURSUP.GRO (curseur vertical)
DCCP 5 GROB_CURS_HORIZ	% contenu du GROB CURSRIGHT.GRO (curseur horizontal)
DCCP 5 GROB_BALLE	% contenu du GROB BALLE.GRO

DCCP 40 BILLES		% 40 = 8billes * (1+2+2)  : 1qt pour direction, 2qts pour X, 2qts pour Y 

DCCP 1 BILLE_D_TMP	% Direction de la bille 
DCCP 2 BILLE_X_TMP	% coordonne X temporaire d'une bille
DCCP 2 BILLE_Y_TMP	% coordonne Y temporaire d'une bille

DCCP 2 TEST_PIX_X	% coordonne X du pixel  tester
DCCP 2 TEST_PIX_Y	% coordonne Y du pixel  tester

DCCP 2 TRAIT_X1		% coordonne X du 1er point du trait a tracer
DCCP 2 TRAIT_Y1		% coordonne Y du 1er point du trait a tracer 
DCCP 2 TRAIT_X2		% coordonne X du 2em point du trait a tracer
DCCP 2 TRAIT_Y2		% coordonne Y du 2em point du trait a tracer 

DCCP 5 PIXELS_LIGNE	% nb de pixels par ligne
DCCP 5 PIXELS_RECT	% nb de pixels par rectangle
DCCP 5 PIXELS_TOTAUX	% nb de pixels totaux


GOSBVL "SAVPTR"       	% sauve les registres    
GOSBVL "DisableIntr"	% empeche toutes les interruptions

GOSUBL INIT

%affichage ecran de presentation
*INTRO
GOSUBL INIT_INTRO


%jeu
GOSUBL INIT_GAME

% la boucle pricipale
{
 GOSUBL niveau_suivant  % teste si passage au niveau suivant
 GOSUBL test_touches    % teste les touches
 GOSUBL trace_trait     % trace le trait si necessaire
 GOSUBL copie_fond      % affiche l'ecran de fond
 GOSUBL copie_trait     % affiche le trait en construction
 GOSUBL gestion_balls   % deplace et affiche les balles en jeu
 GOSUBL aff_curseur     % affiche le sprite du curseur
 GOSUBL copie_ecran     % affiche l'ecran 
 GOSUBL wait            % boucle d'attente
 UP
}


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*niveau_suivant
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste si passage au niveau suivant
D0=(2)PIXELS_TOTAUX
A=DAT0.A
LC(5) ((107*62)*70)/100		% =70% de l'espace

?A<C.A RTNYES			% pas encore 70%

%vide l'espace de jeu
GOSUBL efface_ecran_fond

%1ere bille 
GOSUBL	ajoute_une_bille

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*test_touches
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% gestion des touches
% Attention : masques pour la HP49

	%|DROP|001|6|     DROP pour quitter le jeu
LC 001
OUT=C
GOSBVL "CINRTN"
 ?CBIT=0.6 SKIPYES
  { 
    GOSUBL wait_no_touche
    GOTO INTRO
  }

% si un trait est en train d'etre trac -> on ne bouge plus
?ST=1.2 RTNYES	            

LC 040 
OUT=C
GOSBVL "CINRTN"

D0=(2)coord_X
A=DAT0.B 	            % A contient la coordonne X

	 %|FGauche|040|2|
 ?CBIT=0.2 SKIPYES
  { 
    ST=1.0                  % ST=1.0 si direction horizontale
      ?A=0.B SKIPYES	    % teste si curseur est a la limite gauche
      { A-1.B }
  }
	 %|FDroite|040|0|
 ?CBIT=0.0 SKIPYES
  { 
    ST=1.0
    LC(2)102                % teste si curseur est a la limite droite
    ?A=C.B SKIPYES 
      { A+1.B }
  }

DAT0=A.B                    % on sauve la (nouvelle) coordonne X


LC 040 
OUT=C
GOSBVL "CINRTN"

D0=(2)coord_Y
A=DAT0.B		    % A contient la coordonne Y

	%|FHaut|040|3|
 ?CBIT=0.3 SKIPYES
  { 
    ST=0.0                  % ST=0.0 si direction verticale 
    ?A=0.B SKIPYES          % teste si curseur est a la limite superieure
      { A-1.B }
  }
	%|FBas|040|1|
 ?CBIT=0.1 SKIPYES
  { 
    ST=0.0
    LC(2)57                 % teste si curseur est a la limite inferieure
    ?A=C.B SKIPYES 
      { A+1.B }
  }

DAT0=A.B                    % sauve la (nouvelle) coordonne Y 


	%|VAR|004|7|     change l'orientation du curseur
LC 004
OUT=C
GOSBVL "CINRTN"
?CBIT=0.7 SKIPYES
  {
  ?ST=1.1 EXIT              % flag pour empecher le curseur de tourner en permanence (ST=1.1 si bouton enfonc)
    ST=1.1                  % ST=1.1 quand on appuie et jusqu'a qu'on le relache
    ?ST=0.0 SKIPYES
      { ST=0.0 EXIT2 }      % flag ST(0) pour l'orientation du curseur
      ST=1.0
  }
  SKELSE { ST=0.1 }         % ici le bouton est relach donc on repermet l'action du VAR


	%|APPS|020|7|    pour tracer le trait
LC 020
OUT=C
GOSBVL "CINRTN"
?CBIT=0.7 SKIPYES
  {
   % On demarre du point central du curseur
   D0=(2)coord_X
   C=DAT0.B
   C=C+3.B
   D0=(2)TRAIT_X1
   DAT0=C.B
   D0=(2)TRAIT_X2
   DAT0=C.B
   D0=(2)TEST_PIX_X
   DAT0=C.B
	
   D0=(2)coord_Y
   C=DAT0.B
   C=C+3.B
   D0=(2)TRAIT_Y1
   DAT0=C.B
   D0=(2)TRAIT_Y2
   DAT0=C.B
   D0=(2)TEST_PIX_Y
   DAT0=C.B

   GOSUBL TEST_PIXEL       % si pixel allum, carry = 1
   SKC {
	C=0.A
	C=C-1.A		   % on va faire 2 pixels au meme endroit donc on debute a -1 
	D0=(2)PIXELS_LIGNE
	DAT0=C.A
	ST=1.2
       }          % ST=1.2 -> on trace un trait
  }

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*aff_curseur
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% Affichage du curseur en inverse video dans ECRAN_TRAVAIL
% Utilisation temporaire de R1

% on calcule d'abord l'adresse du quartet ou se trouve le curseur 
C=0.A 
D0=(2)coord_X 
C=DAT0.B 
R1=C.B                    % on met la coordonne X dans R1 pour la rutiliser aprs
CSRB.A                    % on divise X par 4 (4 pixels = bits par quartets) 
CSRB.A  

A=0.A 
D0=(2)coord_Y 
A=DAT0.B 
A+A.A                     % on multiplie Y par 34  (34 quartets par ligne)
C+A.A
ASL.A 
C+A.A                     % on compte de combien de quartets il faut avancer: on a donc fait: C=X/4+Y*34

D0=(2)ECRAN_TRAVAIL
A=DAT0.A                  % adresse du debut de l'ecran
A+C.A                     % on ajoute a l'adresse du debut de l'ecran
D1=A                      % D1 pointe sur l'endroit de l'cran o afficher

{ 
  ?ST=1.0 SKIPYES	  % si direction verticale(ST=1.0) on affiche le curseur vers le haut, 
    { D0=(2)GROB_CURS_HORIZ 
      EXIT2 
    }
    D0=(2)GROB_CURS_VERTI
}  
C=DAT0.A
D0=C                      % D0 pointe sur le sprite a afficher

LC(2)07 D=C.B             % 8 lignes a afficher : D contient le nb de lignes -1
{
 C=R1.B                   % C contient la coordonne X
 A=0.X
 A=DAT0.B
 ?CBIT=0.1 SKIPYES
  { A+A.X A+A.X }
 ?CBIT=0 0 SKIPYES
  { A+A.X }
 C=DAT1.X		  %
 B=A.X  		  %
 A=A!C.X		  % on reprend ce qui est deja affich
 B=B&C.X                  % et on fait un XOR
 A-B.X                    %
 DAT1=A.X 
 D0+2 		
 D1+34  
 D-1.P
 UPNC
}

C=R4.A    		  % adresse des variables
D0=C
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*gestion_balls
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% gestion des 8 balles une par une

D0=(2)BILLES                   % gestion pour la balle 1
GOSUB gestion_1_balle
D0=(2)BILLES+5                 % pour la balle 2
GOSUB gestion_1_balle
D0=(2)BILLES+10                % pour la balle 3
GOSUB gestion_1_balle
D0=(2)BILLES+15                % pour la balle 4
GOSUB gestion_1_balle
D0=(2)BILLES+20                % pour la balle 5
GOSUB gestion_1_balle
D0=(2)BILLES+25                % pour la balle 6
GOSUB gestion_1_balle
D0=(2)BILLES+30                % pour la balle 7
GOSUB gestion_1_balle
D0=(2)BILLES+35                % pour la balle 8
GOSUB gestion_1_balle

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*gestion_1_balle
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% gestion d'une seule balle
% D0 doit pointer sur la balle a traiter
% Utilisation de R0

A=D0
R0=A.A			     % sauvegarde de l'adresse de la bille dans R0
C=DAT0.1
?C=0.P 
RTNYES			     % bille non geree -> retour

  D0=(2)BILLE_D_TMP          % on copie les donnes pour cette balle dans 
  DAT0=C.1                   % les variables temporaires traites par le moteur
  D0=A
  D0+1		             
  C=DAT0.B                   
  D0=(2)BILLE_X_TMP
  DAT0=C.B
  D0=A
  D0+3
  C=DAT0.B  
  D0=(2)BILLE_Y_TMP
  DAT0=C.B

  GOSUB direction_balle      % value la direction de la balle en changeant si necessaire le pas
  GOSUB deplacement_balle    % calcule les nouvelles coordonnes de la balle 
  GOSUB aff_balle            % affiche la balle 
  GOSUB balle_sur_trait      % teste si la balle passe sur le trait en creation

  D0=(2)BILLE_D_TMP          % sauvegarde les nouvelles donnes de la balle 
  C=DAT0.1
  A=R0.A
  D0=A
  DAT0=C.1
  D0=(2)BILLE_X_TMP          
  C=DAT0.B 
  D0=A
  D0+1
  DAT0=C.B
  D0=(2)BILLE_Y_TMP
  C=DAT0.B 
  D0=A
  D0+3
  DAT0=C.B  

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*balle_sur_trait        
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste si la balle passe sur le trait en creation ou le rectangle noirci
% si oui --> efface ECRAN_TRAIT et ST(2)=0

?ST=0.2 RTNYES	% on ne trace pas le trait

% on calcule d'abord l'adresse du quartet ou se trouve la balle
C=0.A 
D0=(2)BILLE_X_TMP
C=DAT0.B 
B=C.B                     % on met la coordonne X dans le registre B pour la rutiliser aprs
CSRB.A                    % on divise X par 4 (4 pixels = bits par quartets) 
CSRB.A  

A=0.A 
D0=(2)BILLE_Y_TMP
A=DAT0.B 
A+A.A                     % on multiplie Y par 34  (34 quartets par ligne)
C+A.A
ASL.A 
C+A.A                     % on compte de combien de quartets il faut avancer: on a donc fait: C=X/4+Y*34

D0=(2)ECRAN_TRAIT
A=DAT0.A                  % adresse du debut de l'ecran
A+C.A                     % on ajoute a l'adresse du debut de l'ecran
D1=A                      % D1 pointe sur l'endroit de l'ecran o devrait s'afficher la balle

D0=(2)GROB_BALLE
C=DAT0.A
D0=C                      % D0 pointe sur le sprite a afficher

LC(2)07 D=C.B             % 8 lignes a afficher : D contient le nb de lignes -1
{
 C=B.B                    % C contient la coordonne X
 A=0.X
 A=DAT0.B
 ?CBIT=0.1 SKIPYES
  { A+A.X A+A.X }
 ?CBIT=0.0 SKIPYES
  { A+A.X } 
 C=DAT1.X	          % on reprend ce qui est deja affich
 A=A&C.X	          % on regarde si ecrasement
 ?A#0.X EXIT		  % on va la fin si ecrasement
 D0+2 		
 D1+34  
 D-1.P
 UPNC

 % fin normale sans ecrasement
 C=R4.A      		  % adresse des variables
 D0=C
 RTN
}

% si on arrive ici c'est que la balle ecrase la ligne
C=R4.A      		  % adresse des variables
D0=C

%efface le trait
GOSUB efface_ecran_trait

ST=0.2			  % on ne trace plus le trait

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*direction_balle        
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% calcul eventuel de la nouvelle direction...
% tout cela est possible car la balle se trouve toujours dans un rectangle

D0=(2)BILLE_D_TMP      % direction
C=DAT0.1

D0=(2)BILLE_X_TMP      % verifie les X
A=DAT0.B
?CBIT=1.0 SKIPYES
 { 
   D0=(2)TEST_PIX_X
   DAT0=A.B            % pixel(teint) a gauche du premier pixel allum de la ligne, l o il faut tester
   D0=(2)BILLE_Y_TMP
   A=DAT0.B
   A+3.B               % on rentre plus a l'interieur du sprite
   D0=(2)TEST_PIX_Y
   DAT0=A.B
   GOSUB TEST_PIXEL    % test de pixel a ces coordonnes
   EXITNC              % quitte si test faux (NO CARRY), ie pas de pixel allum
   D0=(2)BILLE_D_TMP   % direction
   C=DAT0.1
   CBIT=1.0 
   DAT0=C.1            % change la direction           
 }
SKELSE
 { 
   A+6.B               % pixel(teint) a droite du dernier pixel allum, l o il faut tester
   D0=(2)TEST_PIX_X
   DAT0=A.B            
   D0=(2)BILLE_Y_TMP
   A=DAT0.B
   A+3.B               % on rentre plus a l'interieur du sprite
   D0=(2)TEST_PIX_Y
   DAT0=A.B
   GOSUB TEST_PIXEL    % test de pixel a ces coordonnes
   EXITNC              % quitte si test faux (NO CARRY), ie pas de pixel allum
   D0=(2)BILLE_D_TMP   % direction
   C=DAT0.1
   CBIT=0.0            
   DAT0=C.1            % change la direction  
 }

D0=(2)BILLE_D_TMP      % direction
C=DAT0.1

D0=(2)BILLE_Y_TMP      % verifie les Y
A=DAT0.B
?CBIT=1.1 SKIPYES
 { 
   D0=(2)TEST_PIX_Y
   DAT0=A.B            % pixel(teint) au dessus du premier pixel allum de la colonne, l o il faut tester
   D0=(2)BILLE_X_TMP
   A=DAT0.B
   A+3.B               % on rentre plus a l'interieur du sprite
   D0=(2)TEST_PIX_X
   DAT0=A.B
   GOSUB TEST_PIXEL    % test de pixel a ces coordonnes
   EXITNC              % quitte si test donne NO CARRY, ie pas de pixel allum
   D0=(2)BILLE_D_TMP   % direction
   C=DAT0.1
   CBIT=1.1
   DAT0=C.1
 }
SKELSE
 { 
   A+6.B               % pixel(teint) au dessous du dernier pixel allum, l o il faut tester
   D0=(2)TEST_PIX_Y
   DAT0=A.B            
   D0=(2)BILLE_X_TMP
   A=DAT0.B
   A+3.B               % on rentre plus a l'interieur du sprite
   D0=(2)TEST_PIX_X
   DAT0=A.B
   GOSUB TEST_PIXEL    % test de pixel a ces coordonnes
   EXITNC              % quitte si test donne NO CARRY, ie pas de pixel allum
   D0=(2)BILLE_D_TMP   % direction
   C=DAT0.1
   CBIT=0.1
   DAT0=C.1
 }

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*deplacement_balle        
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
%deplacement de la balle (BILLE_X_TMP, BILLE_Y_TMP) avec une direction BILLE_D_TMP

D0=(2)BILLE_D_TMP            % direction
C=DAT0.1

D0=(2)BILLE_X_TMP            % calcule la coordonne de la balle avec la bonne direction
A=DAT0.B
?CBIT=1.0 SKIPYES { A=A-1.B }
 SKELSE { A=A+1.B }
DAT0=A.B

D0=(2)BILLE_Y_TMP
A=DAT0.B  
?CBIT=1.1 SKIPYES { A=A-1.B }
 SKELSE { A=A+1.B }
DAT0=A.B

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*aff_balle
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% affichage de la balle(BILLE_X_TMP, BILLE_Y_TMP) dans ECRAN_TRAVAIL

% on calcule d'abord l'adresse du quartet ou se trouve le sprite
C=0.A 
D0=(2)BILLE_X_TMP
C=DAT0.B 
B=C.B                     % on met la coordonne X dans le registre B pour la rutiliser aprs
CSRB.A                    % on divise X par 4 (4 pixels = bits par quartets) 
CSRB.A  

A=0.A 
D0=(2)BILLE_Y_TMP
A=DAT0.B 
A+A.A                     % on multiplie Y par 34  (34 quartets par ligne)
C+A.A
ASL.A 
C+A.A                     % on compte de combien de quartets il faut avancer: on a donc fait: C=X/4+Y*34

D0=(2)ECRAN_TRAVAIL
A=DAT0.A                  % adresse du debut de l'ecran
A+C.A                     % on ajoute a l'adresse du debut de l'ecran
D1=A                      % D1 pointe sur l'endroit de l'ecran o afficher

D0=(2)GROB_BALLE
C=DAT0.A
D0=C                      % D0 pointe sur le sprite a afficher

LC(2)07 D=C.B             % 8 lignes a afficher : D contient le nb de lignes -1
{
 C=B.B                    % C contient la coordonne X
 A=0.X
 A=DAT0.B
 ?CBIT=0.1 SKIPYES
  { A+A.X A+A.X }
 ?CBIT=0.0 SKIPYES
  { A+A.X }
 C=DAT1.X		  %
 A=A!C.X		  % on reprend ce qui est deja affich
 DAT1=A.X 
 D0+2 		
 D1+34  
 D-1.P
 UPNC
}

C=R4.A      		  % adresse des variables
D0=C
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*test_balls
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste si une des 8 balles est sur le rectangle rempli
% au retour effacement de ECRAN_TRAIT et ST(2)=0 si ecrasement

ST=1.2
% gestion des 8 balles une par une
D0=(2)BILLES                   % gestion pour la balle 1
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+5                 % pour la balle 2
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+10                % pour la balle 3
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+15                % pour la balle 4
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+20                % pour la balle 5
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+25                % pour la balle 6
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+30                % pour la balle 7
GOSUB test_1_balle
?ST=0.2 RTNYES
D0=(2)BILLES+35                % pour la balle 8
GOSUB test_1_balle

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*test_1_balle
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste si une des balles est sur le rectangle rempli
% au retour effacement de ECRAN_TRAIT et ST(2)=0 si ecrasement
% D0 doit pointer sur la balle a traiter

A=D0
C=DAT0.1
?C=0.P 
RTNYES			     % bille non geree -> retour

  % on copie les donnes pour cette balle dans 
  % les variables temporaires
  D0+1		             % pas la direction
  C=DAT0.B                   
  D0=(2)BILLE_X_TMP
  DAT0=C.B
  D0=A
  D0+3
  C=DAT0.B  
  D0=(2)BILLE_Y_TMP
  DAT0=C.B

  GOSUB balle_sur_trait      % teste si la balle passe sur le rectangle en creation

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*trace_trait
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% tracage du trait (un pixel de plus de chaque cote)
% utilisation de D.B pour compter le nb de points eclaire durant cette fonction

?ST=0.2 RTNYES		% on ne trace pas le trait

D=0.B			%pas de pixel eclaire

%test 1er pixel
D0=(2)TRAIT_X1
C=DAT0.B
D0=(2)TEST_PIX_X
DAT0=C.B
D0=(2)TRAIT_Y1
C=DAT0.B
D0=(2)TEST_PIX_Y
DAT0=C.B

GOSUB TEST_PIXEL       	% si pixel allum, carry = 1

SKC { 
	D=D+1.B		%1 pixel eclaire
	D0=(2)TRAIT_X1
	GOSUB PIXEL_ON     

	%calcul nouvelles coordonnees
	?ST=1.0 SKIPYES { D0=(2)TRAIT_X1 } SKELSE { D0=(2)TRAIT_Y1 }
	C=DAT0.B
	C=C-1.B
	DAT0=C.B
} 

%test 2eme pixel
D0=(2)TRAIT_X2
C=DAT0.B
D0=(2)TEST_PIX_X
DAT0=C.B
D0=(2)TRAIT_Y2
C=DAT0.B
D0=(2)TEST_PIX_Y
DAT0=C.B

GOSUB TEST_PIXEL	% si pixel allum, carry = 1

SKC { 
	D=D+1.B		%1 pixel eclaire
	D0=(2)TRAIT_X2
	GOSUB PIXEL_ON     

	%calcul nouvelles coordonnees
	?ST=1.0 SKIPYES { D0=(2)TRAIT_X2 } SKELSE { D0=(2)TRAIT_Y2 }
	C=DAT0.B
	C=C+1.B
	DAT0=C.B
} 

?D#0.B RTNYES		% certains pixels ont ete eclaire -> on continue a tracer

% copie du trait dans le fond
D0=(2)ECRAN_FOND
C=DAT0.A
D1=C
GOSUB copie_trait_bis

%ajout du nb de pixels du trait dans le total
D0=(2)PIXELS_LIGNE
C=DAT0.A
D0=(2)PIXELS_TOTAUX
A=DAT0.A
C=C+A.A
DAT0=C.A

%teste s'il faut remplir un rectangle
GOSUB test_remplissage

ST=0.2			% on ne trace plus le trait

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*test_remplissage
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
%teste s'il faut remplir un rectangle

?ST=1.0 SKIPYES 
 {
 ST=1.3  			%remplissage_dessous
 GOSUB remplissage_horizontal
 
 %test si rectangle OK
 GOSUB test_balls
 ?ST=0.2 SKIPYES		%ecrasement
  {
   % pas d'ecrasement -> on garde le rectangle
 
   % copie du retangle dans le fond
   D0=(2)ECRAN_FOND
   C=DAT0.A
   D1=C
   GOSUB copie_trait_bis

   %efface le rectangle
   GOSUB efface_ecran_trait

   % ajoute le nb de pixel du rectangle au total
   D0=(2)PIXELS_RECT
   C=DAT0.A
   D0=(2)PIXELS_TOTAUX
   A=DAT0.A
   C=C+A.A
   DAT0=C.A

   RTN
  }

  ST=0.3 			%remplissage_dessus
  GOSUB remplissage_horizontal

  %test si rectangle OK
  GOSUB test_balls
  ?ST=0.2 SKIPYES		%ecrasement
  {
   % pas d'ecrasement -> on garde le rectangle
 
   % copie du retangle dans le fond
   D0=(2)ECRAN_FOND
   C=DAT0.A
   D1=C
   GOSUB copie_trait_bis

   %efface le rectangle
   GOSUB efface_ecran_trait

   % ajoute le nb de pixel du rectangle au total
   D0=(2)PIXELS_RECT
   C=DAT0.A
   D0=(2)PIXELS_TOTAUX
   A=DAT0.A
   C=C+A.A
   DAT0=C.A

   RTN
  }
 }
SKELSE
 {
 ST=1.3 			%remplissage_droite
 GOSUB remplissage_vertical

 %test si rectangle OK
 GOSUB test_balls
 ?ST=0.2 SKIPYES		%ecrasement
  {
   % pas d'ecrasement -> on garde le rectangle
 
   % copie du retangle dans le fond
   D0=(2)ECRAN_FOND
   C=DAT0.A
   D1=C
   GOSUB copie_trait_bis

   %efface le rectangle
   GOSUB efface_ecran_trait

   % ajoute le nb de pixel du rectangle au total
   D0=(2)PIXELS_RECT
   C=DAT0.A
   D0=(2)PIXELS_TOTAUX
   A=DAT0.A
   C=C+A.A
   DAT0=C.A

   RTN
  }

 ST=0.3				%remplissage_gauche
 GOSUB remplissage_vertical

 %test si rectangle OK
 GOSUB test_balls
 ?ST=0.2 SKIPYES		%ecrasement
  {
   % pas d'ecrasement -> on garde le rectangle
 
   % copie du retangle dans le fond
   D0=(2)ECRAN_FOND
   C=DAT0.A
   D1=C
   GOSUB copie_trait_bis

   %efface le rectangle
   GOSUB efface_ecran_trait

   % ajoute le nb de pixel du rectangle au total
   D0=(2)PIXELS_RECT
   C=DAT0.A
   D0=(2)PIXELS_TOTAUX
   A=DAT0.A
   C=C+A.A
   DAT0=C.A

   RTN
  }
 }

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*remplissage_horizontal
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% remplissage du rectangle dans ECRAN_TRAIT situe par rapport a (TRAIT_X1, TRAIT_Y1)
% en dessous si ST(3)=1 sinon dessus
% utilisation de R0.W, R1.W et R2.A

% init nb de pixels du rectangle
D0=(2)PIXELS_RECT
C=0.A
DAT0=C.A

%on reprend les coordonnees du point 1 (X1, Y1) et on va dans le bon rectangle
D0=(2)TRAIT_X1
C=DAT0.B
C=C+1 B			%trait horizontal -> toujours a droite du bord gauche
D0=(2)TEST_PIX_X
DAT0=C.B

C=0.A
D0=(2)TRAIT_Y1
C=DAT0.B
D0=(2)TEST_PIX_Y
DAT0=C.B

%D1 sur la ligne ou le trait est dessine
D0=(2)TRAIT_Y1
C=DAT0.B
D0=(2)ECRAN_TRAIT
A=DAT0.A
C=C+C.A
A=A+C.A			% +2Y
CSL.A 
A=A+C.A			% +32Y
D1=A

%sauve le trait dans R0 et R1, R2 = pointeur sur la bonne ligne
R2=A.A
?ST=0.3 SKIPYES	% on a deja sauvegarde pour le test du dessous
{
 C=DAT1.16
 R0=C.W
 D1+16
 C=DAT1.16
 R1=C.W
}

%boucle de remplissage
{
 % ligne suivante
 A=R2.A
 D0=(2)TEST_PIX_Y
 C=DAT0.B
 ?ST=1.3
 SKIPYES { C=C-1.B A=A-34.A }	% en haut
 SKELSE  { C=C+1.B A=A+34.A }	% en bas
 DAT0=C.B
 R2=A.A

 %teste si fini
 GOSUB TEST_PIXEL       % si pixel allum, carry = 1
 RTNC			% retour si Carry

 %copie ligne
 A=R2.A
 D1=A
 A=R0.W
 DAT1=A.16
 D1+16 
 A=R1.W
 DAT1=A.16

 %ajout nb de pixel au rectangle
 D0=(2)PIXELS_LIGNE
 C=DAT0.A
 D0=(2)PIXELS_RECT
 A=DAT0.A
 C=C+A.A
 DAT0=C.A

 UP
}
% pas de RTN ici : la retour se fait dans le corps de la fonction


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*remplissage_vertical
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% remplissage du rectangle dans ECRAN_TRAIT situe par rapport a (TRAIT_X1, TRAIT_Y1)
% a droite si ST(3)=1 sinon a gauche

D0=(2)PIXELS_LIGNE
C=0.A
DAT0=C.A

% on reprend les coordonnees du point 1 (X1, Y1)
% et on va tracer la 1er ligne horizontale du haut
D0=(2)TRAIT_X1
C=DAT0.B
?ST=1.3
SKIPYES { C=C-1.B }	% en gauche
SKELSE  { C=C+1.B }	% en droite
D0=(2)TEST_PIX_X
DAT0=C.B

D0=(2)TRAIT_Y1
C=DAT0.B
?ST=0.3 SKIPYES		% deja passe par la
{
 C=C+1 B		% la 1er ligne horizontale est 1 pixel dessous
 DAT0=C.B
}
D0=(2)TEST_PIX_Y
DAT0=C.B

%boucle pour tracer la 1er ligne horizontale
{
 %teste si fini
 GOSUB TEST_PIXEL       % si pixel allum, carry = 1
 EXITC			% exit si Carry (fin de ligne)

 D0=(2)TEST_PIX_X
 GOSUB PIXEL_ON

 % pixel suivant
 D0=(2)TEST_PIX_X
 C=DAT0.B
 ?ST=1.3
 SKIPYES { C=C-1.B }	% a gauche
 SKELSE  { C=C+1.B }	% a droite
 DAT0=C.B

 UP
}

% la 1ere ligne est tracee -> remplissage_dessous !
ST=1.3 
GOTO remplissage_horizontal



%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*wait            % on bride le programme
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
LC(5)1         % valeur pour la vitesse du jeu
{ C-1.A  UPNC }
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*copie_trait
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% copie l'ecran des traits (ECRAN_TRAIT) dans l'ecran de travail (ECRAN_TRAVAIL)
% en faisant un OR entre les 2 ecrans

D0=(2)ECRAN_TRAVAIL
C=DAT0.A
D1=C
*copie_trait_bis		%entree speciale pour copier ECRAN_TRAIT ailleurs 
D0=(2)ECRAN_TRAIT
C=DAT0.A
D0=C

LC(2) (((136*64)/4)/16)-1
B=C.B
{ 
  A=DAT0.16
  ?A=0.W SKIPYES		% optimisation : si pas de trait, on passe
  {
   C=DAT1.16
   A=A!C.W		        % on reprend ce qui est deja affich
   DAT1=A.16 % a l'adresse pointe par D0
  }
  D0+16      % on avance de 16 les adresses D0 et D1
  D1+16
  B-1.B      % on decremente pour faire la boucle 136 fois
  UPNC 
}

C=R4.A       % adresse des variables
D0=C
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*copie_fond
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% copie l'ecran de fond (ECRAN_FOND) dans l'ecran de travail (ECRAN_TRAVAIL)

D0=(2)ECRAN_TRAVAIL
C=DAT0.A
D1=C
D0=(2)ECRAN_FOND
C=DAT0.A
D0=C

GOTO copie_generique		% un ecran de D0 vers D1


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*copie_ecran
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% copie l'ecran de travail (ECRAN_TRAVAIL) dans l'ecran d'affichage (ECRAN_AFF)

D0=(2)ECRAN_AFF
C=DAT0.A
D1=C
D0=(2)ECRAN_TRAVAIL
C=DAT0.A
D0=C

*copie_generique		% point d'entree pour une copie d'ecran generique
LC(2) (((136*64)/4)/16)-1
{ 
  A=DAT0.16
  DAT1=A.16  % a l'adresse pointe par D0
  D0+16      % on avance de 16 les adresses D0 et D1
  D1+16
  C-1.B      % on decremente pour faire la boucle 136 fois
  UPNC 
}

C=R4.A       % adresse des variables
D0=C
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*efface_ecran_trait
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
%efface ECRAN_TRAIT
D0=(2)ECRAN_TRAIT
C=DAT0.A
D1=C

*efface_ecran_generique 	% efface l'ecran ou pointe D1
A=0.W
LC(2) (((136*64)/4)/16)-1
{ 
  DAT1=A.16
  D1+16
  C-1.B      % on decremente pour faire la boucle 136 fois
  UPNC 
}
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*efface_ecran_fond
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
%vide ECRAN_FOND

D0=(2)ECRAN_FOND
C=DAT0.A
D1=C
D1=D1+34	%pas la 1ere ligne

LC(2) 62-1	% 62 lignes
B=C.B
A=0.W
C=0.W
C=C+1.W
{ 
  DAT1=C.16
  D1+16
  DAT1=A.11
  D1+18
  B-1.B      	% on decremente pour faire la boucle 62 fois
  UPNC 
}

%nb de pixels a 0
C=0.A
D0=(2)PIXELS_LIGNE
DAT0=C.A
D0=(2)PIXELS_RECT
DAT0=C.A
D0=(2)PIXELS_TOTAUX
DAT0=C.A

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*TEST_PIXEL        
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste dans ECRAN_FOND le pixel (TEST_PIX_X, TEST_PIX_Y)
% Au retour si le pixel est allum, la carry passe a 1, sinon la carry est 0

C=0.A 
D0=(2)TEST_PIX_X
C=DAT0.B 
B=C.B                    % on met la coordonne X dans le registre B pour la rutiliser aprs
CSRB.A                   % on divise X par 4 (4 pixels = bits par quartets) 
CSRB.A  

A=0.A 
D0=(2)TEST_PIX_Y
A=DAT0.B 
A+A.A                    % on multiplie Y par 34  (34 quartets par ligne)
C+A.A
ASL.A 
C+A.A                    % on compte de combien de quartets il faut avancer: on a donc fait: C=X/4+Y*34

D0=(2)ECRAN_FOND
A=DAT0.A                 % adresse du debut de l'ecran
A+C.A                    % on ajoute a l'adresse du debut de l'ecran
D1=A                     % D1 pointe sur l'endroit de l'ecran o se trouve le quartet  tester

C=B.B
LA(2)01
?CBIT=0.1 SKIPYES { A+A.B A+A.B }
?CBIT=0.0 SKIPYES { A+A.B }
C=DAT1.B
A&C.P                    % ET logique entre ce qui est affich et l'endroit ou serait affich un point de la balle

?A=0.P SKIPYES { RTNSC } % si test faux, pixel allum, carry devient 1 (SET CARRY)

RTNCC                    % si test vrai, pas de pixel, carry devient 0 (CLEAR) 


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*PIXEL_ON     
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% affiche dans ECRAN_TRAIT
% D0 doit pointer sur les (X,Y) a afficher
% on calcule d'abord l'adresse du quartet ou se trouvera le point

C=0.A 
C=DAT0.B 
B=C.B                     % on met la coordonne X dans le registre B pour la rutiliser aprs
CSRB.A                    % on divise X par 4 (4 pixels = bits par quartets) 
CSRB.A  

A=0.A 
D0=D0+2
A=DAT0.B 
A+A.A                     % on multiplie Y par 34  (34 quartets par ligne)
C+A.A
ASL.A 
C+A.A                     % on compte de combien de quartets il faut avancer: on a donc fait: C=X/4+Y*34

D0=(2)ECRAN_TRAIT
A=DAT0.A                  % adresse du debut de l'ecran
A+C.A                     % on ajoute a l'adresse du debut de l'ecran
D1=A                      % D1 pointe sur l'endroit de l'ecran o allumer le pixel 

C=B.B
LA(2)01
?CBIT=0.1 SKIPYES { A+A.B A+A.B }
?CBIT=0.0 SKIPYES { A+A.B }
C=DAT1.1
A!C.P  
DAT1=A.1

%nb de pixel + 1
D0=(2)PIXELS_LIGNE
C=DAT0.A
C=C+1.A
DAT0=C.A

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*INIT
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% initialisation de Jezz-Ball

% tous les flags ST  0
CLRST		

% P a 0
P=0

%=========================================================================
% ON INITIALISE UN BUFFER DE 1FF QTS ET ON PREND LA 1ER ADRESSE FINISSANT
% PAR xxx00 -> D0 et R4.A
%=========================================================================
 LC 001FF

 %-----------------------------------------------------
 % MAKE$N RETOURNE UNE STRING R0(A) POINTE SUR L'ENTETE
 % D0 POINTE DANS SON CONTENU
 %-----------------------------------------------------
 GOSBVL "MAKE$N"
 AD0EX

 LC 000FF      	% On depasse la 1er adresse en 00
 A+C.A
 A=0.B
 R4=A.A        		% R4 pointe dans la string a la 1ere adresse en 00
 D0=A


% ON INITIALISE UN BUFFER DE 4 ecrans + 1 QT ET ON PREND LA 1ER ADRESSE PAIRE
LC(5) (((136*64)/4)*4)+1
GOSBVL "MAKE$N"
AD0EX
A=A+1.A
ABIT=0.0		% 1ere adresse paire

C=R4.A
D0=C             
D0=(2)ECRAN_AFF        	% sauveagarde l'adresse de l'ecran d'affichage dans (ECRAN_AFF)
DAT0=A.A

D0=(2)ECRAN_TRAVAIL
LC(5) (136*64)/4
A=A+C.A
DAT0=A.A	    	% sauveagarde l'adresse de l'ecran de travail dans (ECRAN_TRAVAIL)
            
D0=(2)ECRAN_FOND
A=A+C.A
DAT0=A.A            	% sauveagarde l'adresse de l'ecran background dans (ECRAN_FOND)

D0=(2)ECRAN_TRAIT
A=A+C.A
DAT0=A.A            	% sauveagarde l'adresse de l'ecran background dans (ECRAN_TRAIT)


%init des grob
GOSUBL BOX
 /BOX.GRO
*BOX
C=RSTK
D0=(2)GROB_BOX
DAT0=C.A

GOSUB CURSEUR_HAUT
 /CURSUP.GRO
*CURSEUR_HAUT     	% Le curseur avec la grande barre verticale
C=RSTK
D0=(2)GROB_CURS_VERTI
DAT0=C.A

GOSUB CURSEUR_DROITE
 /CURSRIGHT.GRO
*CURSEUR_DROITE   	% le curseur avec la grande barre horizontale  -+-
C=RSTK
D0=(2)GROB_CURS_HORIZ
DAT0=C.A

GOSUB BALLE
 /BALLE.GRO
*BALLE            	% la balle
C=RSTK
D0=(2)GROB_BALLE
DAT0=C.A


%on efface ECRAN_AFF et ECRAN_TRAIT
D0=(2)ECRAN_AFF
C=DAT0.A
D1=C
GOSUBL	efface_ecran_generique 

GOSUBL	efface_ecran_trait

% copie de BOX dans ECRAN_FOND       
D0=(2)ECRAN_FOND
A=DAT0.A
D1=A
D0=(2)GROB_BOX
A=DAT0.A
D0=A      
GOSUBL copie_generique	% un ecran de D0 vers D1

%affichage du bon ecran
D0=(2)ECRAN_AFF
C=DAT0.A
D1=(5)DISP1CTL
DAT1=C.A

GOSUBL wait_no_touche

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*INIT_INTRO
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%

% copie de BOX dans ECRAN_AFF       
D0=(2)ECRAN_AFF
A=DAT0.A
D1=A
D0=(2)GROB_BOX
A=DAT0.A
D0=A      
GOSUBL copie_generique	% un ecran de D0 vers D1

{
 %|DROP|001|6|     DROP pour quitter le jeu
 LC 001
 OUT=C
 GOSBVL "CINRTN"
  ?CBIT=0.6 SKIPYES
   { GOTO FIN }

 %|ENTER|001|0|     ENTER pour demarrer
 LC 	001
 OUT=C
 GOSBVL "CINRTN"
 ?CBIT=1.0	EXIT

 UP
}

GOSUB wait_no_touche

RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*INIT_GAME
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% on commence une partie

%toutes les billes a vide
D0=(2)BILLES
C=0.W
DAT0=C.16
D0=D0+16
DAT0=C.16
D0=D0+16
DAT0=C.8

%vide l'espace de jeu
GOSUBL efface_ecran_fond

%1ere bille 
GOSUB	ajoute_une_bille

%init curseur
D0=(2)coord_X LC(2)51 DAT0=C.B      %       
D0=(2)coord_Y LC(2)29 DAT0=C.B      % coordonnes de depart du curseur
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*ajoute_une_bille
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% initialisation des donnes d'une bille
% bit2=1 si bille active, bit1=1 si vers le bas (sinon haut), bit0=1 si vers la droite (gauche sinon)
% direction (en binaire) 0101=haut-droite ; 0111=bas-droite ; 0110=bas-gauche ; 0100=haut-gauche

D0=(2)BILLES

{
 C=DAT0.1
 ?C=0.P EXIT
 D0=D0+5	% bille suivante
 UP
}

LC	F
DAT0=C.1	% en bas a droite
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*wait_no_touche
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
% teste toutes les touches
{
	LC 	1FF
	OUT=C
	GOSBVL "CINRTN"
	?C#0.X	UP
}
RTN


%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
*FIN
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@%
GOSUB wait_no_touche

%affiche la pile
GOSBVL "GETPTR"       		  % restaure les registres    
C=DAT1.A			  % HARDBUFF
C=C+20.A
D1=(5)DISP1CTL
DAT1=C.A

GOSBVL "AllowIntr"
GOVLNG "GETPTRLOOP"

ENDCODE

DROP
;
@